#include <string.h>
#include <stdio.h>

extern int main_udevadm(int argc, char *argv[]);
extern int main_udevd(int argc, char *argv[]);
extern int main_ata_id(int argc, char *argv[]);
extern int main_cdrom_id(int argc, char *argv[]);
extern int main_path_id(int argc, char *argv[]);
extern int main_scsi_id(int argc, char *argv[]);
extern int main_usb_id(int argc, char *argv[]);
extern int main_firmware(int argc, char *argv[]);

int main(int argc, char *argv[])
{
	static const struct {
		const char *n;
		int (*f)(int argc, char *argv[]);
	} *t, tools[] = {
		{"udevadm", main_udevadm},
		{"ata_id", main_ata_id},
		{"cdrom_id", main_cdrom_id},
		{"path_id", main_path_id},
		{"scsi_id", main_scsi_id},
		{"usb_id", main_usb_id},
		{"firmware", main_firmware},
		{"udevd", main_udevd},
		{NULL, NULL}
	};
	const char *n = strrchr(argv[0], '/');

	if (n)
		n++;
	else
		n = argv[0];
	for (t = tools; t->n; t++)
		if (!strcmp(t->n, n))
			return t->f(argc, argv);

	for (t = tools; t->n; t++)
		puts(t->n);
	return 0;
}
